// switch_local.js

var LOGO = "<a class='button' href='http://graf.eit.h-da.de/jxn/JxnPortable/JxnIndex.html'>&nbsp;<i>J&middot;X&middot;</i>N&nbsp;</a> ";

function notLocal()
{
   return window.location.protocol != "file:";
   return true;  // for offline tests comment out the previous line
}


function show_text( httpText, localText )
{
   if( notLocal() )
   {
      document.write( httpText );
   }
   else
   {
      document.write( localText );
   }
}

function show_head_en( folder )
{
   if( folder == null ) folder = "../..";
   if( notLocal() )
   {
      document.write( "<b>*** The following examples (jxn-files) can be executed only locally with <a href='" + folder + "/0_JxnREADME-en.html'>JxnPortable</a> (after <a href='http://graf.eit.h-da.de/jxn/download.html'>download</a>) ***</b>"  );
   }
   else
   {
   // document.write( "The following examples (jxn-files) are executed with JxnPortable, if <i>&nbsp;JxnStart(.bat)</i> is <a target='_blank' href='" + folder + "/0_JxnREADME-en.html#start'>associate</a>d with the filename extension <i>.jxn</i> and [open] is selected." );
      document.write( "<a href=\"javascript:alert('Nothing to start here');\">Start</a> (below) executes the jxn files with JxnPortable." );
   }
}

function show_head_de( folder )
{
   if( folder == null ) folder = "../..";
   if( notLocal() )
   {
      document.write( "<b>*** Folgende Beispiele (jxn-Files) k&ouml;nnen nur lokal mit <a href='" + folder + "/0_JxnREADME-de.html'>JxnPortable</a> (nach <a href='http://graf.eit.h-da.de/jxn/download.html'>Download</a>) ausgef&uuml;hrt werden ***</b>"  );
   }
   else
   {
   // document.write( "Folgende Beispiele (jxn-Files) werden mit JxnPortable ausgef&uuml;hrt, falls <i>&nbsp;JxnStart(.bat)</i> als Dateizuordnung f&uuml;r den Dateityp <i>.jxn</i> <a target='_blank' href='" + folder + "/0_JxnREADME-de.html#start'>eingerichtet</a> ist und die Aktion [&Ouml;ffnen] gew&auml;hlt wird." );
      document.write( "<u>Start</u> f&uuml;hrt die jxn-Files mit JxnPortable aus." );
   }
}


/** writes link to filename.jxn or filename_Start.bat
  * @param filepath with (relative) folder but without the extension (adds .jxn to filename)
  * @text optional text
  */
function writeLink( filepath, text )
{
   var ie = filepath.lastIndexOf( "/" ) + 1;
   var folder = filepath.substring( 0, ie );
   var filename = filepath.substring( ie );
/*
   if( notLocal() || navigator.javaEnabled() == false || navigator.appVersion.indexOf( "Edge" ) < 0 )
   {
      document.write( "<a target='_blank' href='" + folder + filename + ".jxn'>" + filename + ".jxn</a>" );  // jxn with pre
   }
   else  // file for Edge
   {
      document.write( "<a href='" + folder + "start/" + filename + "_Start.bat'>" + filename + ".jxn</a>" );
   }
*/
   if( notLocal() == false )
   {
      if( folder.length == 0 ) document.write( "<a target='_blank' href='" + folder + "files/" + filename + "_Start.bat'>Start</a>&nbsp;" );
   }
   document.write( folder + "<a target='_blank' href='" + folder + "files/" + filename + "_jxn.html'>" + filename + ".jxn</a>" );  // jxn with pre
   if( notLocal() == false )
   {
      if( folder.length > 0 ) document.write( " (<a target='_blank' href='" + folder + "files/" + filename + "_Start.bat'>Start</a>)" );
   }
   if( text != null ) document.write( " " + text );
}

function writeImage( filename, imgName )
{
   var ia = filename.lastIndexOf( '/' ) + 1;
   var filepath = filename.substring( 0, ia ) + "files/" + filename.substring( ia );
   var url = notLocal() ? filepath + "_http.jnlp" : filepath + "_Start.bat";
   if( imgName == null ) imgName = filename + ".png";
   document.writeln( "<a target='_blank' href='" + url + "'><img border='1' width='100%' src='" + imgName + "' /></a>" );
}

function writeStartJXN( filename, ext )
{
// if( ext == null ) ext = filename + ".jxn";
// writeStart( "jnlp/" + filename + "_http.jnlp", "jnlp/" + filename + "_Start.bat", "", ext );
   
   var is = filename.lastIndexOf( '/' ) + 1;
   var filepath = filename.substring( 0, is ) + "files/" + filename.substring( is );
   var url = notLocal() ? filepath + "_http.jnlp" : filepath + "_Start.bat";
   document.write( "<div class='start'><a class='button' target='_blank' href='" + url + "'>&nbsp;Start&nbsp;</a> &nbsp;" );
   writeText( "" );
   
   if( ext == null )
   {
      var jxnUrl = filepath + "_jxn.html";
      document.write( " ( f&uuml;r | for <a target='_blank' href='" + jxnUrl + "'>" + filename + ".jxn</a> )" );
   }
   else
   {
      var ia = ext.lastIndexOf( '/' ) + 1;
      var ie = ext.lastIndexOf( ".jxn" );
      var jxnUrl = ext.substring( 0, ia ) + "files/" + ext.substring( ia, ie ) + "_jxn.html";
      document.write( " ( f&uuml;r | for <a target='_blank' href='" + jxnUrl + "'>" + ext + "</a> )" );
   }
   document.writeln( "</div>" );
}

function writeStartPSCT( filename, ext )  // ME_PSCT, ext: "", ".jxn", "_start.bat"
{
// writeStartLine( filename, "en", "ME_PowerSystemControlTechnology", ext );
   if( ext == null ) ext = filename + ".jxn";
   writeStart( "jnlp/" + filename + "_http.jnlp", "jnlp/" + filename + "_Start.bat", "en", ext );
}

function writeStartEMT( filename, ext )  // BW_EMT
{
// writeStartLine( filename, "de", "BW_Energiemesstechnik", ext );
   if( ext == null ) ext = filename + ".jxn";
   writeStart( "jnlp/" + filename + "_http.jnlp", "jnlp/" + filename + "_Start.bat", "de", ext );
}

function writeStartSPE( filename, ext )  // SPE
{
// writeStartLine( filename, "de", "SternpunktErdung", ext );
   if( ext == null ) ext = filename + ".jxn";
   writeStart( "jnlp/" + filename + "_http.jnlp", "jnlp/" + filename + "_Start.bat", "de", ext );
}

function writeStart( httpUrl, fileUrl, text, jxnUrl )
{
/* Geht nicht: fileUrl mit ..._file.jnlp wird nach erfolgreichem Start vom Browser geloscht
   var url = notLocal() ? httpUrl : fileUrl;
   document.write( "<div class='start'><a class='button' href='" + url + "'>&nbsp;Start&nbsp;</a> &nbsp;" );
*/
// alert( httpUrl + " " + text );
// writeStartLine( replaceTail( httpUrl, "_http.jnlp", "" ), text, "JxnPortable", ".jxn" );
   var url = notLocal() ? httpUrl : replaceTail( fileUrl, "_file.jnlp", "_Start.bat" );  // TODO: later remove replaceTail
   document.write( "<div class='start'><a class='button' target='_blank' href='" + url + "'>&nbsp;Start&nbsp;</a> &nbsp;" );
   writeText( text );
   
   if( notLocal() ) // wrong display of href="filename.jxn" without <pre> for http on Edge
   {
   /* evtl. reaktivieren:
      document.write( " &nbsp; (Alternative: mit <a href='http://graf.eit.h-da.de/jxn/JxnPortable/0_JxnREADME-de.html'>JxnPortable</a> nach <a href='http://graf.eit.h-da.de/jxn/download.html'>Download</a> ausf&uuml;hren "
                           + "| run offline with <a href='http://graf.eit.h-da.de/jxn/JxnPortable/0_JxnREADME-en.html'>JxnPortable</a> after <a href='http://graf.eit.h-da.de/jxn/download.html'>download</a>)" );
   */
   // if( navigator.appVersion.indexOf( "Edge" ) >= 0 ) return;
      if( navigator.javaEnabled() ) return;  // => because jxn w/o pre is not ok for Edge, IE, WindowsPhone
   }
      
   if( jxnUrl != null && jxnUrl != "" /* && navigator.javaEnabled() == false */ )
      document.write( " ( f&uuml;r | for <a target='_blank' href='" + jxnUrl + "'>" + jxnUrl + "</a> )" );
   
   document.write( "</div>" );
}

function replaceTail( filename, oldTail, newTail )
{
/*
   var ia = filename.lastIndexOf( "\\" );
   if( ia < 0 ) ia = filename.lastIndexOf( "/" );
   
   var ie = filename.indexOf( oldTail );
   if( ie < 0 ) ie = filename.indexOf( "." );
   if( ie < 0 ) ie = filename.length;
   
   return filename.substring( ia + 1, ie ) + newTail;
*/
   var ie = filename.indexOf( oldTail );
   if( ie < 0 ) return filename;
   return filename.substring( 0, ie ) + newTail;
}

function writeText( text )
{
   var textDE = "interaktive Anzeige";
   var textEN = "interactive display";
   
   if( text == null || text == "" )
   {
      txt = textDE + " | " + textEN;
   }
   else if( text == "de" )
   {
      txt = textDE;
   }
   else if( text == "en" )
   {
      txt = textEN;
   }
   else if( text == "sw" )
   {
      txt = for_language( textDE, textEN );
   }
   else
   {
      txt = text;
   }
   document.writeln( "<b>" + txt + "</b>" );
}

function writeStartLine( filename, text, root, ext )  // NO MORE USED
{
   var folder = folderFromRoot( root );
   
// alert( filename + "\n" + folder + "\n" + text + " " + ext );
   
   if( notLocal() )
   {
      document.write( "<div class='start'><a class='button' href='jnlp/" + filename + "_http.jnlp'>&nbsp;Start&nbsp;</a> &nbsp;" );
      writeText( text );
   }
   else
   {
      document.write( "<div class='start'>&nbsp;" );
      if( showGerman(text ) )
      {
         document.write( "Interactive Anzeige mit Doppel-Klick auf: " );
      }
      else
      {
         document.write( "Start interactive display double-clicking " );
      }

      var pathSeparator = "/";
      var len = folder.length;
      if( len > 0 ) pathSeparator = folder.charAt( len - 1 );
      
      var fn = filename;
      if( filename.indexOf( "jnlp" ) < 0 )
      {
         fn = folder + "jnlp" + pathSeparator + filename;
      }
      else
      {
         var ie = len - 2;
         while( fn.startsWith( ".." ) )
         {
            fn = fn.substring(3);
            while( ie >= 0 && folder.charAt(ie) != pathSeparator ) ie--;
         }
         fn = folder.substring( 0, ie + 1 ) + fn;
      }
      document.write( "<i>" + fn + "_file.jnlp</i>" );
   }
   
   if( ext == null || ext == "" ) return;
   
   var altFilename = ext;
   if( ext.charAt(0) == "." ) altFilename = filename + ext;
   
   writeAlternative( altFilename, folder, text );
   document.writeln( "</div>" );
}

function writeAlternative( altFilename, folder, text )  // NO MORE USED
{
// InternetExplorer: jxn-Datei wird mit JxnStart.bat <b>in JxnPortable geoeffnet</b> oder JxnPortable wird ohne jxn-Datei geoeffnet<br>
// Edge: jxn-Datei wird angezeigt, JxnPortable wird ohne jxn-Datei geoeffnet<br>
// Firefox, Crome: jxn-Datei oder JxnStart.bat werden <b>im Browser angezeigt</b>
   var DEBUG = false;
   
   if( notLocal() )
   {
      if( folder.startsWith( "JxnPortable" ) == false ) return;  // http: alternative only for jxn
/*
      if( navigator.language.indexOf('de') > -1 )
      {
         document.write( " &nbsp; (Alternative: mit <a href='http://graf.eit.h-da.de/jxn/JxnPortable/0_JxnREADME-de.html'>JxnPortable</a> nach <a href='http://graf.eit.h-da.de/jxn/download.html'>Download</a> ausf&uuml;hren)" );
      }
      else
      {  
         document.write( " &nbsp; (Alternative: run with <a href='http://graf.eit.h-da.de/jxn/JxnPortable/0_JxnREADME-en.html'>JxnPortable</a> after <a href='http://graf.eit.h-da.de/jxn/download.html'>download</a>)" );
      }
*/
      document.write( " &nbsp; (Alternative: mit <a href='http://graf.eit.h-da.de/jxn/JxnPortable/0_JxnREADME-de.html'>JxnPortable</a> nach <a href='http://graf.eit.h-da.de/jxn/download.html'>Download</a> ausf&uuml;hren "
                           + "| run offline with <a href='http://graf.eit.h-da.de/jxn/JxnPortable/0_JxnREADME-en.html'>JxnPortable</a> after <a href='http://graf.eit.h-da.de/jxn/download.html'>download</a>)" );
      return;
   }

   var toRoot = pathToRoot( folder );
   if( DEBUG ) alert( toRoot );
   
   if( DEBUG ) document.write( "JxnPortable/<a href='" + toRoot + "JxnStart.bat?" + altFilename + "'>JxnStart.bat?filename</a> <br>" );
/*
   document.write( " &nbsp; (Alternative: Start&nbsp; <i>" + folder + "<a href='" + altFilename + "'>" + altFilename + "</a></i>"
                  + "&nbsp; via&nbsp; <i>JxnPortable/<a href='" + toRoot + "JxnStart.bat'>JxnStart.bat</a></i>)" );
*/
   if( showGerman( text ) )
   {
      document.write( " &nbsp; (siehe auch <a href='http://graf.eit.h-da.de/jxn/JxnPortable/docs/JxnStartAlternatives.html'>Alternativen</a> zum Start von: <i>"
//                    + folder
                      + "<a target='_blank' href='" + altFilename + "'>" + altFilename + "</a></i>)" );
   }
   else
   {
      document.write( " &nbsp; (see also <a href='http://graf.eit.h-da.de/jxn/JxnPortable/docs/JxnStartAlternatives.html'>alternatives</a> to start: <i>"
//                    + folder
                      + "<a target='_blank' href='" + altFilename + "'>" + altFilename + "</a></i>)" );
   }
}

function showGerman( text )  // NO MORE USED
{
   if( text == null ) return navigator.language.indexOf('de') > -1;
   if( text == "de" ) return true;
   if( text == "en" ) return false;
   return navigator.language.indexOf('de') > -1;
}

function folderFromRoot( root )  // NO MORE USED
{
   var htmlUrl = document.URL;
   ia = htmlUrl.lastIndexOf( root );
   if( ia < 0 ) ia = 0;
   ie = htmlUrl.lastIndexOf( "\\" );
   if( ie < 0 ) ie = htmlUrl.lastIndexOf( "/" );
   return htmlUrl.substring( ia, ie + 1 );
}

function pathToRoot( folder )  // NO MORE USED
{
   var toRoot = "";
   for( var i = 0; i < folder.length - 1; i++ )
   {
      ch = folder.charAt( i );
      if( ch == '\\' )
      {
         toRoot += "..\\";
      }
      else if( ch == '/' )
      {
         toRoot += "../";
      }
      else
      {
      }
   }
   return toRoot;
}


function alertReplaced()
{
alert( for_language( "*** Statisches Bild ersetzt interaktive Anzeige !! ***\n     -> [Start] druecken", "*** Static image replaces interactive display !! ***\n     -> press [Start]" ) );
}


function for_language( deText, stdText )
{
// alert( "for_language: " + deUrl + ", " + stdUrl );
   if( navigator.language.indexOf('de') > -1 )
   {
      return deText;
   }
   else
   {
      return stdText;
   }
}


function switch_language( deUrl, stdUrl )
{
// alert( "switch_language: " + deUrl + ", " + stdUrl );
   if( navigator.language.indexOf('de') > -1 )
   {
      window.location.href = deUrl;
   }
   else
   {
      window.location.href = stdUrl;
   }
}

function switch_href( fileUrl, httpUrl )  // alert, falls httpUrl == null
{
   if( notLocal() == false )
   {
      window.location.href = fileUrl;
   }
   else if( httpUrl != null )
   {
      window.location.href = httpUrl;
   }
   else
   {
      var text = for_language( "Local ausf&uuml;hren mit JxnPortable (nach Download)", "Execute locally with JxnPortable (after download)" );
      alert( text);
   }
}

function switch_href_en( filename, text )  // alert, falls nicht local
{
   if( notLocal() == false )
   {
      window.location.href = filename;
   }
   else if( text == null )
   {
      alert( "Execute locally with JxnPortable (after download)" );
   }
   else
   {
      alert( text );
   }
}

function switch_href_de( filename, text )  // alert, falls nicht local
{
   if( notLocal() == false )
   {
      window.location.href = filename;
   }
   else if( text == null )
   {
   // alert( "Local ausf&uuml;hren mit JxnPortable (nach Download)" );
      alert( "Local ausfuehren mit JxnPortable (nach Download)" );
   }
   else
   {
      alert( text );
   }
}



function swurl( filename )  // hyperlink nur falls local
{
   return notLocal() ? filename : "<a title='execute with JxnPortable' href='" + filename + "'>" + filename + "</a>";
}

function show_href_en( filename )  // abhaengiger Text
{
   if( notLocal() )
   {
      document.write( filename + "&nbsp; available in <a href='../../0_JxnREADME-en.html#variants'>JxnPortable</a> (<a href='http://graf.eit.h-da.de/jxn/download.html'>download</a>)" );
   }
   else
   {
      document.write( "<a title='execute with JxnPortable' href='" + filename + "'>" + filename + "</a>&nbsp; execute with JxnPortable" );
   }
}

function show_href_de( filename )  // abhaengiger Text
{
   if( notLocal() )
   {
      document.write( filename + "&nbsp; verf&uuml;gbar in <a href='../../0_JxnREADME-de.html#variants'>JxnPortable</a> (<a href='http://graf.eit.h-da.de/jxn/download.html'>download</a>)" );
   }
   else
   {
      document.write( "<a title='mit JxnPortable ausf&uuml;hren' href='" + filename + "'>" + filename + "</a>&nbsp; mit JxnPortable ausf&uuml;hren" );
   }
}
